



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>ONVIF开发实例</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">ONVIF开发实例</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-01-31 23:00:28 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<div><strong>&lt;开发过过程中的经验总结&gt;</strong></div>
<div>➤工具的使用</div>
<p><!--more--></p>
<div>&nbsp; &nbsp; (1)首先将文件soapClientLib.c 中"代码"的第二行和第三行注释掉，实际上该文件根本没有用，为了保险起见，仅仅是注释掉。</div>
<div>&nbsp; &nbsp; (2)合理的使用onvif test tool 工具 和 wireshark抓包工具，在开发中难度之一就是不知道代码中结构体中的数据填充具体是多少，所以可以使用onvif test tool 控制设备，抓取该工具发送过去的包，分析如何填充数据。</div>
<div>&nbsp; &nbsp; (3)在onvif test tool 工具中：debug&mdash;&mdash;&gt;request中几乎包含了onvif 中所有的函数接口，和该接口发送的SOAP结构源代码</div>
<div><img referrerpolicy="no-referrer"src="https://images2017.cnblogs.com/blog/1251780/201710/1251780-20171004161744630-2144711305.png" /></p>
<div>&nbsp;➤段错误处理</div>
</div>
<div>&nbsp; &nbsp; (1)因为不同厂家制造的摄像头，有些摄像头并没有将&ldquo;所有的能力&rdquo;实现，这将导致如果一下 获取所有的设备能力，在解析xml 文件的时候，如果解析到一个没有实现的能力，将导致段错误。为了避免出现该问题，解决办法是需要什么能力，就获取什么能力，没有必要一次性获取完。</div>
<div>
<div>
<div>
<pre class="prettyprint linenums">req.Category = (enum tt__CapabilityCategory*)soap_malloc (soap, sizeof(int));<br />
*(req.Category) = (enum tt__CapabilityCategory)5/*(tt__CapabilityCategory__Media)*/;
</pre>
</div>
</div>
</div>
<div>其中enum tt_CapabilityCategory定义如下：</div>
<div>
<div>
<pre class="prettyprint linenums">enum tt__CapabilityCategory {<br />
	tt__CapabilityCategory__All = 0,<br />
	tt__CapabilityCategory__Analytics = 1,<br />
	tt__CapabilityCategory__Device = 2,<br />
	tt__CapabilityCategory__Events = 3,<br />
	tt__CapabilityCategory__Imaging = 4,<br />
	tt__CapabilityCategory__Media = 5,<br />
	tt__CapabilityCategory__PTZ = 6<br />
};
</pre>
</div>
<pre class="prettyprint linenums"><code>&nbsp;</code></pre>
<div>&nbsp;</div>
</div>
<div>&nbsp; &nbsp;&nbsp;(2)因为版本原因，并不是所有的设备都支持extention功能，在tt:Extension中的tt:DHCPv6中，也就是在tt:Extension中，暂时用不到extension中的东西，就注释掉了几个调用的地方，就正常得到Capabilities，前提是extension中是没有数据的，这个原因会到导致解析xml文件出现段错误。所以屏蔽掉这部分的解析代码。</div>
<div>
<pre class="prettyprint linenums">/* file: soapC.c */<br />
SOAP_FMAC3 struct tt__Capabilities * SOAP_FMAC4 soap_in_tt__Capabilities(struct soap *soap, const char *tag, struct tt__Capabilities *a, const char *type)<br />
{<br />
    size_t soap_flag_Analytics = ;<br />
    size_t soap_flag_Device = ;<br />
    size_t soap_flag_Events = ;<br />
    size_t soap_flag_Imaging = ;<br />
    size_t soap_flag_Media = ;<br />
    size_t soap_flag_PTZ = ;<br />
    size_t soap_flag_Extension = ;<br />
    if (soap_element_begin_in(soap, tag, , type))<br />
        return NULL;<br />
    a = (struct tt__Capabilities *)soap_id_enter(soap, soap-&gt;id, a, SOAP_TYPE_tt__Capabilities, sizeof(struct tt__Capabilities), , NULL, NULL, NULL);<br />
    if (!a)<br />
        return NULL;<br />
    soap_default_tt__Capabilities(soap, a);<br />
    if (soap_s2string(soap, soap_attr_value(soap, "-anyAttribute", ), &amp;a-&gt;__anyAttribute, , -))<br />
        return NULL;<br />
    if (soap-&gt;body &amp;&amp; !*soap-&gt;href)<br />
    {<br />
        for (;;)<br />
        {    soap-&gt;error = SOAP_TAG_MISMATCH;<br />
            if (soap_flag_Analytics &amp;&amp; soap-&gt;error == SOAP_TAG_MISMATCH)<br />
                if (soap_in_PointerTott__AnalyticsCapabilities(soap, "tt:Analytics", &amp;a-&gt;Analytics, "tt:AnalyticsCapabilities"))<br />
                {    soap_flag_Analytics--;<br />
                    continue;<br />
                }<br />
            if (soap_flag_Device &amp;&amp; soap-&gt;error == SOAP_TAG_MISMATCH)<br />
                if (soap_in_PointerTott__DeviceCapabilities(soap, "tt:Device", &amp;a-&gt;Device, "tt:DeviceCapabilities"))<br />
                {    soap_flag_Device--;<br />
                    continue;<br />
                }<br />
            if (soap_flag_Events &amp;&amp; soap-&gt;error == SOAP_TAG_MISMATCH)<br />
                if (soap_in_PointerTott__EventCapabilities(soap, "tt:Events", &amp;a-&gt;Events, "tt:EventCapabilities"))<br />
                {    soap_flag_Events--;<br />
                    continue;<br />
                }<br />
            if (soap_flag_Imaging &amp;&amp; soap-&gt;error == SOAP_TAG_MISMATCH)<br />
                if (soap_in_PointerTott__ImagingCapabilities(soap, "tt:Imaging", &amp;a-&gt;Imaging, "tt:ImagingCapabilities"))<br />
                {    soap_flag_Imaging--;<br />
                    continue;<br />
                }<br />
            if (soap_flag_Media &amp;&amp; soap-&gt;error == SOAP_TAG_MISMATCH)<br />
                if (soap_in_PointerTott__MediaCapabilities(soap, "tt:Media", &amp;a-&gt;Media, "tt:MediaCapabilities"))<br />
                {    soap_flag_Media--;<br />
                    continue;<br />
                }<br />
            if (soap_flag_PTZ &amp;&amp; soap-&gt;error == SOAP_TAG_MISMATCH)<br />
                if (soap_in_PointerTott__PTZCapabilities(soap, "tt:PTZ", &amp;a-&gt;PTZ, "tt:PTZCapabilities"))<br />
                {    soap_flag_PTZ--;<br />
                    continue;<br />
                }<br />
            /* wenxy comment */<br />
            /*<br />
            if (soap_flag_Extension &amp;&amp; soap-&gt;error == SOAP_TAG_MISMATCH)<br />
                if (soap_in_PointerTott__CapabilitiesExtension(soap, "tt:Extension", &amp;a-&gt;Extension, "tt:CapabilitiesExtension"))<br />
                {    soap_flag_Extension--;<br />
                    continue;<br />
                }<br />
            */<br />
            if (soap-&gt;error == SOAP_TAG_MISMATCH)<br />
                soap-&gt;error = soap_ignore_element(soap);<br />
            if (soap-&gt;error == SOAP_NO_TAG)<br />
                break;<br />
            if (soap-&gt;error)<br />
                return NULL;<br />
        }<br />
        if (soap_element_end_in(soap, tag))<br />
            return NULL;<br />
    }<br />
    else<br />
    {    a = (struct tt__Capabilities *)soap_id_forward(soap, soap-&gt;href, (void*)a, , SOAP_TYPE_tt__Capabilities, , sizeof(struct tt__Capabilities), , NULL);<br />
        if (soap-&gt;body &amp;&amp; soap_element_end_in(soap, tag))<br />
            return NULL;<br />
    }<br />
    return a;<br />
}

SOAP_FMAC3 struct tt__NetworkCapabilitiesExtension * SOAP_FMAC4 soap_in_tt__NetworkCapabilitiesExtension(struct soap *soap, const char *tag, struct tt__NetworkCapabilitiesExtension *a, const char *type)<br />
{<br />
    struct soap_blist *soap_blist___any = NULL;<br />
    size_t soap_flag_Dot11Configuration = ;<br />
    size_t soap_flag_Extension = ;<br />
    if (soap_element_begin_in(soap, tag, , type))<br />
        return NULL;<br />
    a = (struct tt__NetworkCapabilitiesExtension *)soap_id_enter(soap, soap-&gt;id, a, SOAP_TYPE_tt__NetworkCapabilitiesExtension, sizeof(struct tt__NetworkCapabilitiesExtension), NULL, NULL, NULL, NULL);<br />
    if (!a)<br />
        return NULL;<br />
    soap_default_tt__NetworkCapabilitiesExtension(soap, a);<br />
    if (soap-&gt;body &amp;&amp; *soap-&gt;href != '#')<br />
    {<br />
        for (;;)<br />
        {    soap-&gt;error = SOAP_TAG_MISMATCH;<br />
            if (soap_flag_Dot11Configuration &amp;&amp; soap-&gt;error == SOAP_TAG_MISMATCH)<br />
            {    if (soap_in_PointerToxsd__boolean(soap, "tt:Dot11Configuration", &amp;a-&gt;Dot11Configuration, "xsd:boolean"))<br />
                {    soap_flag_Dot11Configuration--;<br />
                    continue;<br />
                }<br />
            }<br />
            /*if (soap_flag_Extension &amp;&amp; soap-&gt;error == SOAP_TAG_MISMATCH)<br />
            {    if (soap_in_PointerTott__NetworkCapabilitiesExtension2(soap, "tt:Extension", &amp;a-&gt;Extension, "tt:NetworkCapabilitiesExtension2"))<br />
                {    soap_flag_Extension--;<br />
                    continue;<br />
                }<br />
            }*/<br />
            /*if (soap-&gt;error == SOAP_TAG_MISMATCH &amp;&amp; !soap_peek_element(soap))<br />
            {    if (a-&gt;__any == NULL)<br />
                {    if (soap_blist___any == NULL)<br />
                        soap_blist___any = soap_alloc_block(soap);<br />
                    a-&gt;__any = (char *)soap_push_block_max(soap, soap_blist___any, sizeof(char));<br />
                    if (a-&gt;__any == NULL)<br />
                        return NULL;<br />
                    soap_default_byte(soap, a-&gt;__any);<br />
                }<br />
                if (soap_in_byte(soap, "-any", a-&gt;__any, "xsd:byte"))<br />
                {    a-&gt;__size++;<br />
                    a-&gt;__any = NULL;<br />
                    continue;<br />
                }<br />
            }*/<br />
            if (soap-&gt;error == SOAP_TAG_MISMATCH)<br />
                soap-&gt;error = soap_ignore_element(soap);<br />
            if (soap-&gt;error == SOAP_NO_TAG)<br />
                break;<br />
            if (soap-&gt;error)<br />
                return NULL;<br />
        }<br />
        if (a-&gt;__any)<br />
            soap_pop_block(soap, soap_blist___any);<br />
        if (a-&gt;__size)<br />
        {    a-&gt;__any = (char *)soap_save_block(soap, soap_blist___any, NULL, );<br />
        }<br />
        else<br />
        {    a-&gt;__any = NULL;<br />
            if (soap_blist___any)<br />
                soap_end_block(soap, soap_blist___any);<br />
        }<br />
        if (soap_element_end_in(soap, tag))<br />
            return NULL;<br />
    }<br />
    else<br />
    {    a = (struct tt__NetworkCapabilitiesExtension *)soap_id_forward(soap, soap-&gt;href, (void*)a, , SOAP_TYPE_tt__NetworkCapabilitiesExtension, SOAP_TYPE_tt__NetworkCapabilitiesExtension, sizeof(struct tt__NetworkCapabilitiesExtension), , NULL, NULL);<br />
        if (soap-&gt;body &amp;&amp; soap_element_end_in(soap, tag))<br />
            return NULL;<br />
    }<br />
    return a;<br />
}

SOAP_FMAC3 struct tt__Capabilities * SOAP_FMAC4 soap_in_tt__Capabilities(struct soap *soap, const char *tag, struct tt__Capabilities *a, const char *type)<br />
{<br />
    size_t soap_flag_Analytics = ;<br />
    size_t soap_flag_Device = ;<br />
    size_t soap_flag_Events = ;<br />
    size_t soap_flag_Imaging = ;<br />
    size_t soap_flag_Media = ;<br />
    size_t soap_flag_PTZ = ;<br />
    size_t soap_flag_Extension = ;<br />
    if (soap_element_begin_in(soap, tag, , type))<br />
        return NULL;<br />
    a = (struct tt__Capabilities *)soap_id_enter(soap, soap-&gt;id, a, SOAP_TYPE_tt__Capabilities, sizeof(struct tt__Capabilities), NULL, NULL, NULL, NULL);<br />
    if (!a)<br />
        return NULL;<br />
    soap_default_tt__Capabilities(soap, a);<br />
    if (soap_s2char(soap, soap_attr_value(soap, "-anyAttribute", , ), &amp;a-&gt;__anyAttribute, , , -, NULL))<br />
        return NULL;<br />
    if (soap-&gt;body &amp;&amp; *soap-&gt;href != '#')<br />
    {<br />
        for (;;)<br />
        {    soap-&gt;error = SOAP_TAG_MISMATCH;<br />
            if (soap_flag_Analytics &amp;&amp; soap-&gt;error == SOAP_TAG_MISMATCH)<br />
            {    if (soap_in_PointerTott__AnalyticsCapabilities(soap, "tt:Analytics", &amp;a-&gt;Analytics, "tt:AnalyticsCapabilities"))<br />
                {    soap_flag_Analytics--;<br />
                    continue;<br />
                }<br />
            }<br />
            if (soap_flag_Device &amp;&amp; soap-&gt;error == SOAP_TAG_MISMATCH)<br />
            {    if (soap_in_PointerTott__DeviceCapabilities(soap, "tt:Device", &amp;a-&gt;Device, "tt:DeviceCapabilities"))<br />
                {    soap_flag_Device--;<br />
                    continue;<br />
                }<br />
            }<br />
            if (soap_flag_Events &amp;&amp; soap-&gt;error == SOAP_TAG_MISMATCH)<br />
            {    if (soap_in_PointerTott__EventCapabilities(soap, "tt:Events", &amp;a-&gt;Events, "tt:EventCapabilities"))<br />
                {    soap_flag_Events--;<br />
                    continue;<br />
                }<br />
            }<br />
            if (soap_flag_Imaging &amp;&amp; soap-&gt;error == SOAP_TAG_MISMATCH)<br />
            {    if (soap_in_PointerTott__ImagingCapabilities(soap, "tt:Imaging", &amp;a-&gt;Imaging, "tt:ImagingCapabilities"))<br />
                {    soap_flag_Imaging--;<br />
                    continue;<br />
                }<br />
            }<br />
            if (soap_flag_Media &amp;&amp; soap-&gt;error == SOAP_TAG_MISMATCH)<br />
            {    if (soap_in_PointerTott__MediaCapabilities(soap, "tt:Media", &amp;a-&gt;Media, "tt:MediaCapabilities"))<br />
                {    soap_flag_Media--;<br />
                    continue;<br />
                }<br />
            }<br />
            if (soap_flag_PTZ &amp;&amp; soap-&gt;error == SOAP_TAG_MISMATCH)<br />
            {    if (soap_in_PointerTott__PTZCapabilities(soap, "tt:PTZ", &amp;a-&gt;PTZ, "tt:PTZCapabilities"))<br />
                {    soap_flag_PTZ--;<br />
                    continue;<br />
                }<br />
            }<br />
            /*if (soap_flag_Extension &amp;&amp; soap-&gt;error == SOAP_TAG_MISMATCH)<br />
            {    if (soap_in_PointerTott__CapabilitiesExtension(soap, "tt:Extension", &amp;a-&gt;Extension, "tt:CapabilitiesExtension"))<br />
                {    soap_flag_Extension--;<br />
                    continue;<br />
                }<br />
            }*/<br />
            if (soap-&gt;error == SOAP_TAG_MISMATCH)<br />
                soap-&gt;error = soap_ignore_element(soap);<br />
            if (soap-&gt;error == SOAP_NO_TAG)<br />
                break;<br />
            if (soap-&gt;error)<br />
                return NULL;<br />
        }<br />
        if (soap_element_end_in(soap, tag))<br />
            return NULL;<br />
    }<br />
    else<br />
    {    a = (struct tt__Capabilities *)soap_id_forward(soap, soap-&gt;href, (void*)a, , SOAP_TYPE_tt__Capabilities, SOAP_TYPE_tt__Capabilities, sizeof(struct tt__Capabilities), , NULL, NULL);<br />
        if (soap-&gt;body &amp;&amp; soap_element_end_in(soap, tag))<br />
            return NULL;<br />
    }<br />
    return a;<br />
}</pre>
</div>
<div>
<div>&nbsp;</div>
</div>
<div>&nbsp; &nbsp; 因为摄像头2D转动已经包含了1D转动功能，但是在将代码中的数据转换成xml文件的过程中，会出现段错误，经过索引发现是在将数据转换成1D对应的xml文件的过程中出现错误，所以将这部分代码屏蔽。</div>
<div>
<div>
<pre class="prettyprint linenums">SOAP_FMAC3 int SOAP_FMAC4 soap_out_tt__PTZSpeed(struct soap *soap, const char *tag, int id, const struct tt__PTZSpeed *a, const char *type)<br />
{<br />
    (void)soap; (void)tag; (void)id; (void)a; (void)type; /* appease -Wall -Werror */<br />
    if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE_tt__PTZSpeed), type))<br />
        return soap-&gt;error;<br />
    if (soap_out_PointerTott__Vector2D(soap, "tt:PanTilt", -, &amp;a-&gt;PanTilt, ""))<br />
        return soap-&gt;error;<br />
    /*<br />
    if (soap_out_PointerTott__Vector1D(soap, "tt:Zoom", -1, &amp;a-&gt;Zoom, ""))<br />
        return soap-&gt;error;<br />
    */<br />
    return soap_element_end_out(soap, tag);<br />
}</pre>
</div>
<pre class="prettyprint linenums"><code>&nbsp;</code></pre>
<div>&nbsp;</div>
</div>
<div>&nbsp; &nbsp; 在摄像头设置网关的过程中，出现段错误，经过反复检查，发现是参数设置错误。</div>
<div>
<div>
<pre class="prettyprint linenums">int ONVIF_SetNetworkDefaultGateway(char *device_ip)<br />
{<br />
    char new_gateway[] = {};<br />
    char *ip_p = new_gateway;<br />
#if 1<br />
    printf("please input new gateway:");<br />
    scanf("%s" , new_gateway);<br />
    if(strcmp(new_gateway , "q") == )<br />
    {<br />
        return ;<br />
    }<br />
    printf("the new gateway is :%s\n" , new_gateway);<br />
#endif

    int result = -;<br />
    int size = ;<br />
    struct soap *soap = NULL;// point of soap<br />
    struct _tds__SetNetworkDefaultGateway req;//requst<br />
    struct _tds__SetNetworkDefaultGatewayResponse resp;// respone

    //size = strlen(ip_p);<br />
    req.IPv4Address = &amp;ip_p;<br />
    req.__sizeIPv4Address = ;

    SOAP_ASSERT(NULL != (soap = ONVIF_soap_new(SOAP_SOCK_TIMEOUT)));<br />
    ONVIF_SetAuthInfo(soap, USERNAME, PASSWORD);

    result = soap_call___tds__SetNetworkDefaultGateway(soap , device_ip , NULL , &amp;req ,&amp;resp);<br />
    printf("result is                 :%d\n" , result);

    ONVIF_soap_delete(soap);<br />
}</pre>
</div>
<pre class="prettyprint linenums"><code>&nbsp;</code></pre>
<div>&nbsp;</div>
</div>
<div>&ldquo;req.__sizeIPv4Address = 1&ldquo; ，该参数对应的不是IP地址的长度，是IP地址的个数。</div>
<div>➤调试技巧</div>
<div>&nbsp;➣打印信息</div>
<div>&nbsp; &nbsp;&nbsp;在编写Makefile的时候，加上编译选项"-DDEBUG"这样在发送和接收过程中，在当前目录下就会生成RECV.log ,SENT.log,TEST.log这三个文件，分别对应发送，接收的xml文件，和日志打印信息。</div>
<div>&nbsp;➣段错误索引</div>
<div>&nbsp; &nbsp; 在编写Makefile的时候，加上编译选项"-g"，执行make 命令之前，先执行命令"ulimit -c unlimited",如果出现段错误，在当前路径下就会生成一个叫&ldquo;core.*&rdquo;的文件。</div>
<div>&nbsp; &nbsp; 然后执行命令：gdb 程序名称 core.*&nbsp;</div>
<div>&nbsp; &nbsp; 接着执行命令：where&nbsp;</div>
<div>这样就可以索引段错误发生在哪里了。</div>
<div>
<div>
<div>
<pre class="prettyprint linenums">onvif:main.o soapClientLib.o wsaapi.o stdsoap2.o soapC.o duration.o soapClient.o wsseapi.o mecevp.o smdevp.o threads.o dom.o<br />
    gcc  -g -DDEBUG main.o soapClientLib.o wsaapi.o stdsoap2.o soapC.o duration.o soapClient.o wsseapi.o mecevp.o smdevp.o  threads.o dom.o -lssl -lcrypto -o onvif<br />
main.o:main.c<br />
    gcc -c -g -DDEBUG  main.c -o main.o<br />
soapClientLib.o:soapClientLib.c<br />
    gcc -c -g -DDEBUG  soapClientLib.c -o soapClientLib.o<br />
wsaapi.o:wsaapi.c<br />
    gcc -c -g -DDEBUG  wsaapi.c -o wsaapi.o<br />
stdsoap2.o:stdsoap2.c<br />
    gcc -c -g -DDEBUG  -DWITH_OPENSSL stdsoap2.c -o stdsoap2.o<br />
soapC.o:soapC.c<br />
    gcc -c -g -DDEBUG  soapC.c -o soapC.o<br />
duration.o:duration.c<br />
    gcc -c -g -DDEBUG  duration.c -o duration.o<br />
soapClient.o:soapClient.c<br />
    gcc -c -g -DDEBUG  soapClient.c -o soapClient.o<br />
wsseapi.o:wsseapi.c<br />
    gcc -c -g -DDEBUG  wsseapi.c -o wsseapi.o<br />
mecevp.o:mecevp.c<br />
    gcc -c -g -DDEBUG  mecevp.c -o mecevp.o<br />
smdevp.o:smdevp.c<br />
    gcc -c -g -DDEBUG  smdevp.c -o smdevp.o<br />
threads.o:threads.c<br />
    gcc -c -g -DDEBUG  threads.c -o threads.o<br />
dom.o:dom.c<br />
    gcc -c -g -DDEBUG  dom.c -o dom.o<br />
.PHONY:clean<br />
clean:<br />
    rm -rf *.o</pre>
</div>
<pre class="prettyprint linenums"><code>&nbsp;</code></pre>
<div>&nbsp;</div>
</div>
</div>
<div>&nbsp;</div>
<div><strong>&lt;代码实例&gt;</strong></div>
<div>
<div>
<pre class="prettyprint linenums">#include &lt;stdio.h&gt;<br />
#include &lt;signal.h&gt;<br />
#include &lt;stdlib.h&gt;<br />
#include &lt;assert.h&gt;<br />
#include &lt;string.h&gt;<br />
#include "soapH.h"<br />
#include "wsaapi.h"<br />
#include "soapStub.h"<br />
#include "wsdd.nsmap"<br />
#include "stdsoap2.h"

#define USERNAME    "admin"<br />
#if 0<br />
#define PASSWORD    "goldsun123"<br />
#endif<br />
#define PASSWORD    "admin123"

#define SOAP_ASSERT     assert<br />
#define SOAP_DBGLOG     printf<br />
#define SOAP_DBGERR     printf

#define SOAP_TO         "urn:schemas-xmlsoap-org:ws:2005:04:discovery"<br />
#define SOAP_ACTION     "http://schemas.xmlsoap.org/ws/2005/04/discovery/Probe"

#define SOAP_MCAST_ADDR "soap.udp://239.255.255.250:3702"// onvif multicast address

#define SOAP_ITEM       ""// scope of device<br />
#define SOAP_TYPES      "dn:NetworkVideoTransmitter"// type of device

#define SOAP_SOCK_TIMEOUT    (1)// socket timeout<br />
#define ONVIF_TOKEN_SIZE     65 // 唯一标识该视频编码器的令牌字符串

#define SOAP_CHECK_ERROR(result, soap, str) \<br />
    do { \<br />
        if (SOAP_OK != (result) || SOAP_OK != (soap)-&gt;error) { \<br />
            soap_perror((soap), (str)); \<br />
            if (SOAP_OK == (result)) { \<br />
                (result) = (soap)-&gt;error; \<br />
            } \<br />
            goto EXIT;\<br />
        } \<br />
    } while ()

/*configuration of video encode */<br />
struct tagVideoEncoderConfiguration<br />
{<br />
    char token[ONVIF_TOKEN_SIZE];// video token<br />
    int Width;// resolution ratio<br />
    int Height;<br />
};

/* configuration of device */<br />
struct tagProfile {<br />
    char token[ONVIF_TOKEN_SIZE];// device token

    struct tagVideoEncoderConfiguration venc;// video encoding configuration information<br />
};

//enum tt__CapabilityCategory my_category;

void soap_perror(struct soap *soap, const char *str)<br />
{<br />
    if (NULL == str) {<br />
        SOAP_DBGERR("[soap] error: %d, %s, %s\n", soap-&gt;error, *soap_faultcode(soap), *soap_faultstring(soap));<br />
    } else {<br />
        SOAP_DBGERR("[soap] %s error: %d, %s, %s\n", str, soap-&gt;error, *soap_faultcode(soap), *soap_faultstring(soap));<br />
    }<br />
    return;<br />
}

void* ONVIF_soap_malloc(struct soap *soap, unsigned int n)<br />
{<br />
    void *p = NULL;

    if (n &gt; ) {<br />
        p = soap_malloc(soap, n);<br />
        SOAP_ASSERT(NULL != p);<br />
        memset(p, 0x00 ,n);<br />
    }<br />
    return p;<br />
}

struct soap *ONVIF_soap_new(int timeout)<br />
{<br />
    struct soap *soap = NULL;// onvif soap

    SOAP_ASSERT(NULL != (soap = soap_new()));

    soap_set_namespaces(soap, namespaces);// set soap namespaces<br />
    soap-&gt;recv_timeout    = timeout;// timeout<br />
    soap-&gt;send_timeout    = timeout;<br />
    soap-&gt;connect_timeout = timeout;

#if defined(__linux__) || defined(__linux) // 参考https://www.genivia.com/dev.html#client-c的修改：<br />
    soap-&gt;socket_flags = MSG_NOSIGNAL;                                          // To prevent connection reset errors<br />
#endif

    soap_set_mode(soap, SOAP_C_UTFSTRING);// set encoding of character

    return soap;<br />
}

void ONVIF_soap_delete(struct soap *soap)<br />
{<br />
    soap_destroy(soap); // remove deserialized class instances (C++ only)<br />
    soap_end(soap); // Clean up deserialized data (except class instances) and temporary data<br />
    soap_done(soap);// Reset, close communications, and remove callbacks<br />
    soap_free(soap);// Reset and deallocate the context created with soap_new or soap_copy<br />
}

void ONVIF_init_header(struct soap *soap)<br />
{<br />
    struct SOAP_ENV__Header *header = NULL;

    SOAP_ASSERT(NULL != soap);

    header = (struct SOAP_ENV__Header *)ONVIF_soap_malloc(soap, sizeof(struct SOAP_ENV__Header));//in heap<br />
    soap_default_SOAP_ENV__Header(soap, header);<br />
    header-&gt;wsa__MessageID = (char*)soap_wsa_rand_uuid(soap);//get uuid<br />
    header-&gt;wsa__To        = (char*)ONVIF_soap_malloc(soap, strlen(SOAP_TO) + );<br />
    header-&gt;wsa__Action    = (char*)ONVIF_soap_malloc(soap, strlen(SOAP_ACTION) + );<br />
    strcpy(header-&gt;wsa__To, SOAP_TO);<br />
    strcpy(header-&gt;wsa__Action, SOAP_ACTION);<br />
    soap-&gt;header = header;

    return;<br />
}

void ONVIF_init_ProbeType(struct soap *soap, struct wsdd__ProbeType *probe)<br />
{<br />
    struct wsdd__ScopesType *scope = NULL;// 用于描述查找哪类的Web服务

    SOAP_ASSERT(NULL != soap);<br />
    SOAP_ASSERT(NULL != probe);

    scope = (struct wsdd__ScopesType *)ONVIF_soap_malloc(soap, sizeof(struct wsdd__ScopesType));<br />
    soap_default_wsdd__ScopesType(soap, scope);// 设置寻找设备的范围<br />
    scope-&gt;__item = (char*)ONVIF_soap_malloc(soap, strlen(SOAP_ITEM) + );<br />
    strcpy(scope-&gt;__item, SOAP_ITEM);

    memset(probe, 0x00, sizeof(struct wsdd__ProbeType));<br />
    soap_default_wsdd__ProbeType(soap, probe);<br />
    probe-&gt;Scopes = scope;<br />
    probe-&gt;Types  = (char*)ONVIF_soap_malloc(soap, strlen(SOAP_TYPES) + );// 设置寻找设备的类型<br />
    strcpy(probe-&gt;Types, SOAP_TYPES);

    return;<br />
}

static int ONVIF_SetAuthInfo(struct soap *soap, const char *username, const char *password)<br />
{<br />
    int result = ;

    SOAP_ASSERT(NULL != username);<br />
    SOAP_ASSERT(NULL != password);

    result = soap_wsse_add_UsernameTokenDigest(soap, NULL, username, password);<br />
    SOAP_CHECK_ERROR(result, soap, "add_UsernameTokenDigest");

EXIT:

    return result;<br />
}

void ONVIF_DetectDevice(void (*cb)(char *DeviceXAddr) , char *ip)<br />
{<br />
    int i;<br />
    int result = ;<br />
    unsigned int count = ;// count of device<br />
    struct soap *soap = NULL;// soap<br />
    struct wsdd__ProbeType      req;// request<br />
    struct __wsdd__ProbeMatches resp;// respone<br />
    struct wsdd__ProbeMatchType *probeMatch;

    SOAP_ASSERT(NULL != (soap = ONVIF_soap_new(SOAP_SOCK_TIMEOUT)));

    ONVIF_init_header(soap);// init header<br />
    ONVIF_init_ProbeType(soap, &amp;req);//set scope and type<br />
    result = soap_send___wsdd__Probe(soap, SOAP_MCAST_ADDR, NULL, &amp;req);// send request<br />
    while (SOAP_OK == result)// receive respone<br />
    {<br />
        memset(&amp;resp, 0x00, sizeof(resp));<br />
        result = soap_recv___wsdd__ProbeMatches(soap, &amp;resp);<br />
        if (SOAP_OK == result) {<br />
            if (soap-&gt;error) {<br />
                soap_perror(soap, "ProbeMatches");<br />
            }<br />
                else<br />
                {<br />
                    for(i = ; i &lt; resp.wsdd__ProbeMatches-&gt;__sizeProbeMatch; i++)//display information<br />
                    {<br />
                        printf("__sizeProbeMatch        : %d\n", resp.wsdd__ProbeMatches-&gt;__sizeProbeMatch);<br />
                        printf("wsa__EndpointReference  : %p\n", resp.wsdd__ProbeMatches-&gt;ProbeMatch-&gt;wsa__EndpointReference);<br />
                        printf("Target EP Address       : %s\n", resp.wsdd__ProbeMatches-&gt;ProbeMatch-&gt;wsa__EndpointReference.Address);<br />
                        printf("Target Type             : %s\n", resp.wsdd__ProbeMatches-&gt;ProbeMatch-&gt;Types);<br />
                        printf("Target Service Address  : %s\n", resp.wsdd__ProbeMatches-&gt;ProbeMatch-&gt;XAddrs);<br />
                        memcpy(ip , resp.wsdd__ProbeMatches-&gt;ProbeMatch-&gt;XAddrs , strlen(resp.wsdd__ProbeMatches-&gt;ProbeMatch-&gt;XAddrs));<br />
                        printf("Target Metadata Version : %d\n", resp.wsdd__ProbeMatches-&gt;ProbeMatch-&gt;MetadataVersion);<br />
                        if(resp.wsdd__ProbeMatches-&gt;ProbeMatch-&gt;Scopes)<br />
                        {<br />
                            printf("Target Scopes Address   : %s\n\n", resp.wsdd__ProbeMatches-&gt;ProbeMatch-&gt;Scopes-&gt;__item);<br />
                        }<br />
                   }<br />
               if (NULL != resp.wsdd__ProbeMatches)<br />
                    {<br />
                        count += resp.wsdd__ProbeMatches-&gt;__sizeProbeMatch;<br />
                  for(i = ; i &lt; resp.wsdd__ProbeMatches-&gt;__sizeProbeMatch; i++)<br />
                        {<br />
                            probeMatch = resp.wsdd__ProbeMatches-&gt;ProbeMatch + i;<br />
                     if (NULL != cb)<br />
                            {<br />
                                cb(probeMatch-&gt;XAddrs);    // run callback function<br />
                     }<br />
                  }<br />
                    }<br />
            }<br />
        }<br />
          else if (soap-&gt;error)<br />
          {<br />
            break;<br />
        }<br />
    }

    //SOAP_DBGLOG("\ndetect end! It has detected %d devices!\n", count);<br />
    if (NULL != soap)<br />
     {<br />
        ONVIF_soap_delete(soap);<br />
    }<br />
    return ;<br />
}

//set ip address<br />
int ONVIF_SetNetworkInterfaces(char *old_addr ,char *new_ip , char *device_token)<br />
{<br />
    //char new_addr[128] = {"192.168.1.200"};<br />
    int result = SOAP_ERR;<br />
   if( old_addr != NULL &amp;&amp;  != strlen(old_addr) )<br />
    {<br />
        struct soap soap;<br />
        soap_init(&amp;soap);<br />
        struct _tds__SetNetworkInterfaces req = {};<br />
        struct _tds__SetNetworkInterfacesResponse rsp;

        //rsp.RebootNeeded = 1;//设置后重启

        //char interface[32] = "eth0";<br />
        req.InterfaceToken = device_token;//要设置的设备网络接口<br />
        //xsd__boolean dhcp = xsd__boolean__true_;<br />
          //network.Enabled = 1;<br />
        enum xsd__boolean netEnable = xsd__boolean__true_;<br />
        enum xsd__boolean ipv4Enable = xsd__boolean__true_;<br />
        enum xsd__boolean DHCP = xsd__boolean__false_;<br />
        enum xsd__boolean autoneg = xsd__boolean__true_;<br />
        enum xsd__boolean duplex = tt__Duplex__Full;<br />
        struct tt__NetworkInterfaceConnectionSetting net_set;<br />
        net_set.AutoNegotiation = autoneg;<br />
        net_set.Speed = ;<br />
        net_set.Duplex = duplex;

        struct tt__NetworkInterfaceSetConfiguration network;<br />
        soap_default_tt__NetworkInterfaceSetConfiguration(&amp;soap, &amp;network);<br />
        network.Enabled = &amp;netEnable;<br />
        network.Link = &amp;net_set;

        struct tt__IPv4NetworkInterfaceSetConfiguration tt_ipv4;<br />
        soap_default_tt__IPv4NetworkInterfaceSetConfiguration(&amp;soap, &amp;tt_ipv4);

        struct tt__PrefixedIPv4Address  tt_prefAddr;<br />
        soap_default_tt__PrefixedIPv4Address(&amp;soap, &amp;tt_prefAddr);<br />
        tt_prefAddr.Address = new_ip;//the new ip address<br />
        tt_prefAddr.PrefixLength = ;

        tt_ipv4.Manual = &amp;tt_prefAddr;<br />
        tt_ipv4.__sizeManual = ;//important<br />
        tt_ipv4.DHCP = &amp;DHCP;<br />
        tt_ipv4.Enabled = &amp;ipv4Enable;

        network.IPv4 = &amp;tt_ipv4;

        int mtuLen = ;<br />
        network.MTU = &amp;mtuLen;

        //printf("%d\n", network.IPv4-&gt;Manual-&gt;PrefixLength);<br />
        //printf("%s\n", network.IPv4-&gt;Manual-&gt;Address);<br />
        req.NetworkInterface = &amp;network;

        ONVIF_SetAuthInfo(&amp;soap, USERNAME, PASSWORD);<br />
        result = soap_call___tds__SetNetworkInterfaces(&amp;soap,old_addr, NULL, &amp;req, &amp;rsp);<br />
        if(result == SOAP_OK)<br />
        {<br />
            printf("SetNetworkInterfaces successful\n");<br />
        }<br />
        soap_destroy(&amp;soap);<br />
        soap_end(&amp;soap);<br />
        soap_done(&amp;soap);<br />
    }<br />
    return result;

}

int ONVIF_GetDeviceInformation(const char *DeviceXAddr)<br />
{<br />
    int result = ;<br />
    struct soap *soap = NULL;<br />
    struct _tds__GetDeviceInformation           devinfo_req;<br />
    struct _tds__GetDeviceInformationResponse   devinfo_resp;

    SOAP_ASSERT(NULL != DeviceXAddr);<br />
    SOAP_ASSERT(NULL != (soap = ONVIF_soap_new(SOAP_SOCK_TIMEOUT)));

    ONVIF_SetAuthInfo(soap, USERNAME, PASSWORD);

    memset(&amp;devinfo_req, 0x00, sizeof(devinfo_req));<br />
    memset(&amp;devinfo_resp, 0x00, sizeof(devinfo_resp));<br />
    result = soap_call___tds__GetDeviceInformation(soap, DeviceXAddr, NULL, &amp;devinfo_req, &amp;devinfo_resp);<br />
    SOAP_CHECK_ERROR(result, soap, "GetDeviceInformation");<br />
     printf("\n\n");<br />
     printf("SerialNumber number is :%d\n" , devinfo_resp.SerialNumber );

    EXIT:

    if (NULL != soap) {<br />
        ONVIF_soap_delete(soap);<br />
    }<br />
    return result;<br />
}

int ONVIF_GetCapabilities(const char *device_server , char *media_ip , char *ptz_ip)<br />
{<br />
    int result = ;<br />
    struct soap *soap = NULL;<br />
    struct _tds__GetCapabilities            req;<br />
    struct _tds__GetCapabilitiesResponse    resp;

    SOAP_ASSERT(NULL != device_server);<br />
    SOAP_ASSERT(NULL != (soap = ONVIF_soap_new(SOAP_SOCK_TIMEOUT)));<br />
    memset(&amp;req, 0x00, sizeof(req));

    memset(&amp;resp, 0x00, sizeof(resp));<br />
    req.__sizeCategory = ;<br />
    req.Category = (enum tt__CapabilityCategory*)soap_malloc (soap, sizeof(int));<br />
    *(req.Category) = (enum tt__CapabilityCategory)/*(tt__CapabilityCategory__Media)*/;

    ONVIF_SetAuthInfo(soap, USERNAME, PASSWORD);

    result = soap_call___tds__GetCapabilities(soap, device_server, NULL, &amp;req, &amp;resp);<br />
    printf("\n\n");<br />
    //printf("result is :%d\n", result);<br />
    SOAP_CHECK_ERROR(result, soap, "GetCapabilities");<br />
    if(strlen(resp.Capabilities-&gt;Media-&gt;XAddr) &gt; )<br />
    {<br />
        return -;<br />
    }<br />
    else<br />
    {<br />
        memcpy(media_ip , resp.Capabilities-&gt;Media-&gt;XAddr , strlen(resp.Capabilities-&gt;Media-&gt;XAddr));<br />
    }<br />
    printf("media addr is                 :%s\n" , resp.Capabilities-&gt;Media-&gt;XAddr);<br />
    /*get PTZ address*/<br />
    req.__sizeCategory = ;<br />
    req.Category = (enum tt__CapabilityCategory*)soap_malloc (soap, sizeof(int));<br />
    *(req.Category) = (enum tt__CapabilityCategory)/*(tt__CapabilityCategory__Media)*/;<br />
    result = soap_call___tds__GetCapabilities(soap, device_server, NULL, &amp;req, &amp;resp);<br />
    printf("\n\n");<br />
    SOAP_CHECK_ERROR(result, soap, "GetCapabilities");<br />
#if 1<br />
    if(resp.Capabilities-&gt;PTZ == NULL)<br />
    {<br />
        printf("unsurpport PTZ\n");<br />
        return -;<br />
    }<br />
    if(strlen(resp.Capabilities-&gt;PTZ-&gt;XAddr) &gt; )<br />
    {<br />
        return -;<br />
    }<br />
    else<br />
    {<br />
        memcpy(ptz_ip , resp.Capabilities-&gt;PTZ-&gt;XAddr , strlen(resp.Capabilities-&gt;PTZ-&gt;XAddr));<br />
    }<br />
    //printf("PTZ addr is                   :%s\n" , resp.Capabilities-&gt;PTZ-&gt;XAddr);<br />
#endif<br />
EXIT:

    if (NULL != soap) {<br />
        ONVIF_soap_delete(soap);<br />
    }<br />
    return result;<br />
}

int ONVIF_GetZeroConfiguration(char *addr , char *device_token)<br />
{<br />
    int result = ;<br />
    struct soap *soap = NULL;<br />
    struct _tds__GetZeroConfiguration  req;<br />
    struct _tds__GetZeroConfigurationResponse resp; 

    SOAP_ASSERT(NULL != (soap = ONVIF_soap_new(SOAP_SOCK_TIMEOUT)));<br />
    ONVIF_SetAuthInfo(soap, USERNAME, PASSWORD);

    result = soap_call___tds__GetZeroConfiguration(soap , addr , NULL , &amp;req , &amp;resp);<br />
    if(strlen(resp.ZeroConfiguration-&gt;InterfaceToken)  &gt; )<br />
    {<br />
        return -;<br />
    }<br />
    else<br />
    {<br />
        memcpy(device_token , resp.ZeroConfiguration-&gt;InterfaceToken , strlen(resp.ZeroConfiguration-&gt;InterfaceToken));<br />
    }<br />
    printf("\ntoken is       :%s\n" , resp.ZeroConfiguration-&gt;InterfaceToken);<br />
    ONVIF_soap_delete(soap);<br />
    return result;

}

int ONVIF_GetStreamUri(const char *MediaXAddr, char *ProfileToken)<br />
{<br />
    int result = ;<br />
    char uri[] = {};<br />
    struct soap *soap = NULL;<br />
    struct tt__StreamSetup              ttStreamSetup;<br />
    struct tt__Transport                ttTransport;<br />
    struct _trt__GetStreamUri           req;<br />
    struct _trt__GetStreamUriResponse   resp;

    SOAP_ASSERT(NULL != MediaXAddr);

    SOAP_ASSERT(NULL != (soap = ONVIF_soap_new(SOAP_SOCK_TIMEOUT)));

    memset(&amp;req, 0x00, sizeof(req));<br />
    memset(&amp;resp, 0x00, sizeof(resp));<br />
    memset(&amp;ttStreamSetup, 0x00, sizeof(ttStreamSetup));<br />
    memset(&amp;ttTransport, 0x00, sizeof(ttTransport));<br />
    ttStreamSetup.Stream                = tt__StreamType__RTP_Unicast;<br />
    ttStreamSetup.Transport             = &amp;ttTransport;<br />
    ttStreamSetup.Transport-&gt;Protocol   = tt__TransportProtocol__RTSP;<br />
    ttStreamSetup.Transport-&gt;Tunnel     = NULL;<br />
    req.StreamSetup                     = &amp;ttStreamSetup;<br />
    req.ProfileToken                    = ProfileToken;

    ONVIF_SetAuthInfo(soap, USERNAME, PASSWORD);<br />
    result = soap_call___trt__GetStreamUri(soap, MediaXAddr, NULL, &amp;req, &amp;resp);<br />
    SOAP_CHECK_ERROR(result, soap, "GetServices");<br />
    printf("uri is               :%s\n", resp.MediaUri-&gt;Uri);

EXIT:

    if (NULL != soap) {<br />
        ONVIF_soap_delete(soap);<br />
    }<br />
    return result;<br />
}<br />
/*get media profile*/<br />
int ONVIF_Media_GetProfiles(const char *Media_ip)<br />
{<br />
    int i = ;<br />
    int result = ;<br />
    int stmno = ;<br />
    struct soap *soap = NULL;<br />
    struct tagProfile *profiles = NULL;<br />
    struct _trt__GetProfiles            req;<br />
    struct _trt__GetProfilesResponse    resp;

    SOAP_ASSERT(NULL != Media_ip);<br />
    SOAP_ASSERT(NULL != (soap = ONVIF_soap_new(SOAP_SOCK_TIMEOUT)));

    ONVIF_SetAuthInfo(soap, USERNAME, PASSWORD);

    memset(&amp;req, 0x00, sizeof(req));<br />
    memset(&amp;resp, 0x00, sizeof(resp));<br />
    result = soap_call___trt__GetProfiles(soap, Media_ip, NULL, &amp;req, &amp;resp);<br />
    printf("&gt;&gt;&gt;result is :%d\n" , result);<br />
    SOAP_CHECK_ERROR(result, soap, "GetProfiles");<br />
     //printf information of profiles<br />
     printf("\n\n");<br />
     printf("__sizeprofiles is  :%d\n" , resp.__sizeProfiles);<br />
     printf("name is            :%s\n" , resp.Profiles-&gt;Name);<br />
     printf("token is           :%s\n" , resp.Profiles-&gt;VideoSourceConfiguration-&gt;token);<br />
     printf("sourcetoken is     :%s\n" , resp.Profiles-&gt;VideoSourceConfiguration-&gt;SourceToken);<br />
     printf("usecoutn is        :%d\n" , resp.Profiles-&gt;VideoEncoderConfiguration-&gt;UseCount);<br />
     printf("__size is          :%d\n" , resp.Profiles-&gt;VideoEncoderConfiguration-&gt;__size);<br />
     printf("__any is           :%d\n" , resp.Profiles-&gt;VideoEncoderConfiguration-&gt;__any );<br />
     printf("profile token is   :%s\n" , resp.Profiles-&gt;token);<br />
     printf("\n\n");<br />
    if (resp.__sizeProfiles &gt; )<br />
    {<br />
        profiles = (struct tagProfile *)malloc(resp.__sizeProfiles * sizeof(struct tagProfile));//malloc cache<br />
        SOAP_ASSERT(NULL != profiles);<br />
        memset(profiles, 0x00, resp.__sizeProfiles * sizeof(struct tagProfile));<br />
    }<br />
    /*resolve respone*/<br />
    for(i = ; i &lt; resp.__sizeProfiles; i++) {<br />
        struct tt__Profile *RespProfile = &amp;resp.Profiles[i];<br />
        struct tagProfile *StoreProfile = &amp;profiles[i];

        if (NULL != RespProfile-&gt;token)// store Token<br />
        {<br />
            strncpy(StoreProfile-&gt;token, RespProfile-&gt;token, sizeof(StoreProfile-&gt;token) - );<br />
        }

        if (NULL != RespProfile-&gt;VideoEncoderConfiguration) //video encode configuration<br />
        {<br />
            if (NULL != RespProfile-&gt;VideoEncoderConfiguration-&gt;token) // store video Token<br />
            {<br />
                strncpy(StoreProfile-&gt;venc.token, RespProfile-&gt;VideoEncoderConfiguration-&gt;token, sizeof(StoreProfile-&gt;venc.token) - );<br />
            }<br />
            if (NULL != RespProfile-&gt;VideoEncoderConfiguration-&gt;Resolution) // video resolutio<br />
            {<br />
                StoreProfile-&gt;venc.Width  = RespProfile-&gt;VideoEncoderConfiguration-&gt;Resolution-&gt;Width;<br />
                StoreProfile-&gt;venc.Height = RespProfile-&gt;VideoEncoderConfiguration-&gt;Resolution-&gt;Height;<br />
            }<br />
        }<br />
          ONVIF_GetStreamUri(Media_ip , profiles[i].token);<br />
          printf("profile token is     :%s\n" , StoreProfile-&gt;token);<br />
          printf("video token is       :%s\n" , StoreProfile-&gt;venc.token);<br />
          printf("video width is       :%d\n" , StoreProfile-&gt;venc.Width);<br />
          printf("video height is      :%d\n" , StoreProfile-&gt;venc.Height);<br />
          if(RespProfile-&gt;VideoEncoderConfiguration-&gt;Encoding == )<br />
          {<br />
                printf("video encode is      :JPEG\n");<br />
          }<br />
          if(RespProfile-&gt;VideoEncoderConfiguration-&gt;Encoding == )<br />
          {<br />
                printf("video encode is      :MPEG4\n");<br />
          }<br />
          if(RespProfile-&gt;VideoEncoderConfiguration-&gt;Encoding == )<br />
          {<br />
                printf("video encode is      :H264\n");<br />
          }<br />
            printf("\n");<br />
    }

     return resp.__sizeProfiles;<br />
EXIT:

    if (NULL != soap) {<br />
        ONVIF_soap_delete(soap);<br />
    }

    return resp.__sizeProfiles;<br />
}<br />
/*get PTZ profiles*/<br />
int ONVIF_PTZ_GetProfiles(const char *media_ip , char *absolute_ip , char *zoom_ip)<br />
{<br />
    int i = ;<br />
    int result = ;<br />
    struct soap *soap = NULL;<br />
    struct tagProfile *profiles = NULL;<br />
    struct _trt__GetProfiles            req;<br />
    struct _trt__GetProfilesResponse    resp;

    SOAP_ASSERT(NULL != media_ip);<br />
    SOAP_ASSERT(NULL != (soap = ONVIF_soap_new(SOAP_SOCK_TIMEOUT)));

    ONVIF_SetAuthInfo(soap, USERNAME, PASSWORD);

    memset(&amp;req, 0x00, sizeof(req));<br />
    memset(&amp;resp, 0x00, sizeof(resp));<br />
    result = soap_call___trt__GetProfiles(soap, media_ip, NULL, &amp;req, &amp;resp);<br />
    printf("result is :%d\n" ,result);<br />
    SOAP_CHECK_ERROR(result, soap, "GetProfiles");<br />
     //printf information of profiles<br />
     printf("\n\n");<br />
     printf("__sizeprofiles is                             :%d\n" , resp.__sizeProfiles);<br />
     printf("name is                                       :%s\n" , resp.Profiles-&gt;Name);<br />
     printf("token is                                      :%s\n" , resp.Profiles-&gt;PTZConfiguration-&gt;token);<br />
     printf("NodeToken is                                  :%s\n" , resp.Profiles-&gt;PTZConfiguration-&gt;NodeToken);<br />
     printf("UseCount is                                   :%d\n" , resp.Profiles-&gt;PTZConfiguration-&gt;UseCount);<br />
     printf("DefaultAbsolutePantTiltPositionSpace is       :%d\n" , resp.Profiles-&gt;PTZConfiguration-&gt;DefaultAbsolutePantTiltPositionSpace);<br />
     printf("DefaultAbsoluteZoomPositionSpace is           :%d\n" , resp.Profiles-&gt;PTZConfiguration-&gt;DefaultAbsoluteZoomPositionSpace);<br />
     printf("DefaultRelativePanTiltTranslationSpace is     :%d\n" , resp.Profiles-&gt;PTZConfiguration-&gt;DefaultRelativePanTiltTranslationSpace );<br />
     printf("DefaultRelativeZoomTranslationSpace is        :%s\n" , resp.Profiles-&gt;PTZConfiguration-&gt;DefaultRelativeZoomTranslationSpace);<br />
     printf("DefaultRelativeZoomTranslationSpace is        :%s\n" , resp.Profiles-&gt;PTZConfiguration-&gt;DefaultRelativeZoomTranslationSpace);<br />
     printf("DefaultContinuousPanTiltVelocitySpace is      :%s\n" , resp.Profiles-&gt;PTZConfiguration-&gt;DefaultContinuousPanTiltVelocitySpace);<br />
     printf("DefaultContinuousZoomVelocitySpace is         :%s\n" , resp.Profiles-&gt;PTZConfiguration-&gt;DefaultContinuousZoomVelocitySpace);<br />
     printf("DefualtPTZTimeout is                          :%d\n" , *(resp.Profiles-&gt;PTZConfiguration-&gt;DefaultPTZTimeout));<br />
     printf("DefaultPTZSpeed Vector2D PanTilt x is         :%f\n" , resp.Profiles-&gt;PTZConfiguration-&gt;DefaultPTZSpeed-&gt;PanTilt-&gt;x);<br />
     printf("DefaultPTZSpeed dVector2D PanTilt y is        :%f\n" , resp.Profiles-&gt;PTZConfiguration-&gt;DefaultPTZSpeed-&gt;PanTilt-&gt;y);<br />
     printf("DefaultPTZSpeed dVector2D PanTilt space is    :%s\n" , resp.Profiles-&gt;PTZConfiguration-&gt;DefaultPTZSpeed-&gt;PanTilt-&gt;space);<br />
     memcpy(absolute_ip ,resp.Profiles-&gt;PTZConfiguration-&gt;DefaultPTZSpeed-&gt;PanTilt-&gt;space , strlen(resp.Profiles-&gt;PTZConfiguration-&gt;DefaultPTZSpeed-&gt;PanTilt-&gt;space));<br />
     printf("DefaultPTZSpeed Vector1D Zoom x is            :%f\n" , resp.Profiles-&gt;PTZConfiguration-&gt;DefaultPTZSpeed-&gt;Zoom-&gt;x);<br />
     printf("DefaultPTZSpeed Vector2D Zoom space is        :%s\n" , resp.Profiles-&gt;PTZConfiguration-&gt;DefaultPTZSpeed-&gt;Zoom-&gt;space);<br />
     printf("PanTiltLimits Range  URI is                   :%s\n" ,resp.Profiles-&gt;PTZConfiguration-&gt;PanTiltLimits-&gt;Range-&gt;URI);<br />
     printf("PanTiltLimits Range  XRange Min  is           :%f\n" ,resp.Profiles-&gt;PTZConfiguration-&gt;PanTiltLimits-&gt;Range-&gt;XRange-&gt;Min);<br />
     printf("PanTiltLimits Range  XRange Max is            :%f\n" ,resp.Profiles-&gt;PTZConfiguration-&gt;PanTiltLimits-&gt;Range-&gt;XRange-&gt;Max);<br />
     printf("PanTiltLimits Range  YRange Min  is           :%f\n" ,resp.Profiles-&gt;PTZConfiguration-&gt;PanTiltLimits-&gt;Range-&gt;YRange-&gt;Min);<br />
     printf("PanTiltLimits Range  YRange Max is            :%f\n" ,resp.Profiles-&gt;PTZConfiguration-&gt;PanTiltLimits-&gt;Range-&gt;YRange-&gt;Max);<br />
     printf("ZoomLimits Range  URI is                      :%s\n" ,resp.Profiles-&gt;PTZConfiguration-&gt;ZoomLimits-&gt;Range-&gt;URI);<br />
     memcpy(zoom_ip , resp.Profiles-&gt;PTZConfiguration-&gt;ZoomLimits-&gt;Range-&gt;URI , strlen(resp.Profiles-&gt;PTZConfiguration-&gt;ZoomLimits-&gt;Range-&gt;URI));<br />
     printf("ZoomLimits Range  XRange Min is               :%f\n" ,resp.Profiles-&gt;PTZConfiguration-&gt;ZoomLimits-&gt;Range-&gt;XRange-&gt;Min);<br />
     printf("ZoomLimits Range  XRange Max is               :%f\n" ,resp.Profiles-&gt;PTZConfiguration-&gt;ZoomLimits-&gt;Range-&gt;XRange-&gt;Max);

     printf("\n\n");<br />
#if 0<br />
    if (resp.__sizeProfiles &gt; )<br />
    {                                               // 分配缓存<br />
        profiles = (struct tagProfile *)malloc(resp.__sizeProfiles * sizeof(struct tagProfile));<br />
        SOAP_ASSERT(NULL != profiles);<br />
        memset(profiles, 0x00, resp.__sizeProfiles * sizeof(struct tagProfile));<br />
    }

    for(i = ; i &lt; resp.__sizeProfiles; i++) {                                   // 提取所有配置文件信息<br />
        struct tt__Profile *RespProfile = &amp;resp.Profiles[i];<br />
        struct tagProfile *StoreProfile = &amp;profiles[i];

        if (NULL != RespProfile-&gt;token)// store Token<br />
        {<br />
            strncpy(StoreProfile-&gt;token, RespProfile-&gt;token, sizeof(StoreProfile-&gt;token) - );<br />
        }

        if (NULL != RespProfile-&gt;VideoEncoderConfiguration) //video encode configuration<br />
        {<br />
            if (NULL != RespProfile-&gt;VideoEncoderConfiguration-&gt;token) // store video Token<br />
            {<br />
                strncpy(StoreProfile-&gt;venc.token, RespProfile-&gt;VideoEncoderConfiguration-&gt;token, sizeof(StoreProfile-&gt;venc.token) - );<br />
            }<br />
            if (NULL != RespProfile-&gt;VideoEncoderConfiguration-&gt;Resolution) // video resolutio<br />
            {<br />
                StoreProfile-&gt;venc.Width  = RespProfile-&gt;VideoEncoderConfiguration-&gt;Resolution-&gt;Width;<br />
                StoreProfile-&gt;venc.Height = RespProfile-&gt;VideoEncoderConfiguration-&gt;Resolution-&gt;Height;<br />
            }<br />
        }<br />
          ONVIF_GetStreamUri(MediaXAddr , profiles[i].token);<br />
          printf("profile token is     :%s\n" , StoreProfile-&gt;token);<br />
          printf("video token is       :%s\n" , StoreProfile-&gt;venc.token);<br />
          printf("video width is       :%d\n" , StoreProfile-&gt;venc.Width);<br />
          printf("video height is      :%d\n" , StoreProfile-&gt;venc.Height);<br />
          if(RespProfile-&gt;VideoEncoderConfiguration-&gt;Encoding == )<br />
          {<br />
                printf("video encode is      :JPEG\n");<br />
          }<br />
          if(RespProfile-&gt;VideoEncoderConfiguration-&gt;Encoding == )<br />
          {<br />
                printf("video encode is      :MPEG4\n");<br />
          }<br />
          if(RespProfile-&gt;VideoEncoderConfiguration-&gt;Encoding == )<br />
          {<br />
                printf("video encode is      :H264\n");<br />
          }<br />
            printf("\n");<br />
    }<br />
#endif<br />
     return resp.__sizeProfiles;<br />
EXIT:

    if (NULL != soap) {<br />
        ONVIF_soap_delete(soap);<br />
    }

    return resp.__sizeProfiles;<br />
}

int ONVIF_Get_Gateway(char *device_ip)<br />
{<br />
    int result = -;<br />
    struct soap *soap = NULL;// point of soap<br />
    struct _tds__GetNetworkDefaultGateway      req;//requst<br />
    struct _tds__GetNetworkDefaultGatewayResponse resp;// respone

    SOAP_ASSERT(NULL != (soap = ONVIF_soap_new(SOAP_SOCK_TIMEOUT)));

    ONVIF_SetAuthInfo(soap, USERNAME, PASSWORD);<br />
    result = soap_call___tds__GetNetworkDefaultGateway(soap , device_ip , NULL , &amp;req , &amp;resp);

    printf("result is :%d\n" , result);<br />
#if 1<br />
    if(*(resp.NetworkGateway-&gt;IPv4Address) == NULL)<br />
    {<br />
        printf("can't get gateway address \n");<br />
        return -;<br />
    }<br />
    else<br />
    {<br />
        printf("the gateway address is          :%s\n" , *(resp.NetworkGateway-&gt;IPv4Address));<br />
    }<br />
#endif<br />
    ONVIF_soap_delete(soap);<br />
    return ;<br />
}

int ONVIF_SetNetworkDefaultGateway(char *device_ip)<br />
{<br />
    char new_gateway[] = {};<br />
    char *ip_p = new_gateway;<br />
#if 1<br />
    printf("please input new gateway:");<br />
    scanf("%s" , new_gateway);<br />
    if(strcmp(new_gateway , "q") == )<br />
    {<br />
        return ;<br />
    }<br />
    printf("the new gateway is :%s\n" , new_gateway);<br />
#endif

    int result = -;<br />
    int size = ;<br />
    struct soap *soap = NULL;// point of soap<br />
    struct _tds__SetNetworkDefaultGateway req;//requst<br />
    struct _tds__SetNetworkDefaultGatewayResponse resp;// respone

    //size = strlen(ip_p);<br />
    req.IPv4Address = &amp;ip_p;<br />
    req.__sizeIPv4Address = ;

    SOAP_ASSERT(NULL != (soap = ONVIF_soap_new(SOAP_SOCK_TIMEOUT)));<br />
    ONVIF_SetAuthInfo(soap, USERNAME, PASSWORD);

    result = soap_call___tds__SetNetworkDefaultGateway(soap , device_ip , NULL , &amp;req ,&amp;resp);<br />
    printf("result is                 :%d\n" , result);

    ONVIF_soap_delete(soap);<br />
}

#if 1<br />
int ONVIF_AbsoluteMove(char *ptz_ip , char *absolute_move_ip  , char *absolute_zoom_ip)<br />
{

    int result = -;<br />
    struct soap *soap = NULL;// pointer of soap<br />
    struct _tptz__AbsoluteMove req;<br />
    struct _tptz__AbsoluteMoveResponse resp;

    struct tt__Vector2D vector2d;<br />
    vector2d.x = -;//absolute x angle<br />
    vector2d.y = -;//absolute y angle<br />
    vector2d.space = absolute_move_ip;<br />
#if 1<br />
    struct tt__Vector1D vector1d;<br />
    vector1d.x = ;//absolute foci<br />
    vector1d.space = absolute_zoom_ip;<br />
#endif

    struct tt__PTZVector ptzvector;<br />
    ptzvector.PanTilt = &amp;vector2d;<br />
    ptzvector.Zoom = &amp;vector1d;

    req.Position = &amp;ptzvector;<br />
    req.ProfileToken = "Profile_1";<br />
    req.Speed = NULL;

    SOAP_ASSERT(NULL != (soap = ONVIF_soap_new(SOAP_SOCK_TIMEOUT)));

    result = ONVIF_SetAuthInfo(soap, USERNAME, PASSWORD);

    printf("ONvif_SetAuthInfo is :%d\n" , result);

    result =soap_call___tptz__AbsoluteMove(soap , ptz_ip , NULL , &amp;req , &amp;resp);<br />
    sleep();<br />
    ONVIF_soap_delete(soap);<br />
    printf("result is            :%d\n" , result);<br />
    return result;<br />
}<br />
#endif

#if 0<br />
#endifSOAP_FMAC5 int SOAP_FMAC6 soap_call___tptz__RelativeMove(struct soap *soap, const char *soap_endpoint, const char *soap_action, struct _tptz__RelativeMove *tptz__RelativeMove, struct _tptz__RelativeMoveResponse *tptz__RelativeMoveResponse)<br />
#endif

int ONVIf_RelativeMove(char *tpz_ip , char *relative_move_ip  , char *relative_zoom_ip )<br />
{<br />
    int result = -;<br />
    struct soap *soap = NULL;// pointer of soap<br />
    struct _tptz__RelativeMove req;<br />
    struct _tptz__RelativeMoveResponse resp;

    struct tt__Vector2D vector2d;<br />
    vector2d.x = 0.3;<br />
    vector2d.y = 0.4;<br />
    vector2d.space = relative_move_ip;

    struct tt__Vector1D vector1d;<br />
    vector1d.x = 0.5;<br />
    vector1d.space = relative_zoom_ip;

    struct tt__PTZVector ptzvector;<br />
    ptzvector.PanTilt = &amp;vector2d;<br />
    ptzvector.Zoom = &amp;vector1d;

    req.ProfileToken = "Profile_1";<br />
    req.Translation = &amp;ptzvector;<br />
    req.Speed = NULL;

    SOAP_ASSERT(NULL != (soap = ONVIF_soap_new(SOAP_SOCK_TIMEOUT)));

    result = ONVIF_SetAuthInfo(soap, USERNAME, PASSWORD);<br />
    printf("ONvif_SetAuthInfo is :%d\n" , result);

    result = soap_call___tptz__RelativeMove(soap , tpz_ip , NULL , &amp;req ,&amp;resp);

    ONVIF_soap_delete(soap);

    printf("result is               :%d\n" , result);<br />
    return result;<br />
}

int ONVIF_Stop()<br />
{

    char *ptz_ip = "http://192.168.235.201/onvif/PTZ";<br />
    int result = -;<br />
    struct soap *soap = NULL;// pointer of soap<br />
    struct _tptz__Stop req;<br />
    struct _tptz__StopResponse resp;

    enum xsd__boolean stop_rote = xsd__boolean__true_;<br />
    enum xsd__boolean stop_foci = xsd__boolean__false_; 

    req.PanTilt = &amp;stop_rote;<br />
    req.Zoom = &amp;stop_foci;<br />
    req.ProfileToken = "Profile_1";

    SOAP_ASSERT(NULL != (soap = ONVIF_soap_new(SOAP_SOCK_TIMEOUT)));<br />
    result = ONVIF_SetAuthInfo(soap, USERNAME, PASSWORD);

    printf("ONvif_SetAuthInfo is :%d\n" , result);<br />
    result = soap_call___tptz__Stop(soap , ptz_ip , NULL , &amp;req , &amp;resp);

    ONVIF_soap_delete(soap);<br />
}

int ONVIF_ContinuousMove(char *ptz_ip , char *continuous_move_ip , char *continuous_zoom_ip)<br />
{<br />
    int result = -;<br />
    struct soap *soap = NULL;// pointer of soap<br />
    struct _tptz__ContinuousMove req;<br />
    struct _tptz__ContinuousMoveResponse resp;

    struct tt__Vector2D vector2d;<br />
    vector2d.x = ;<br />
    vector2d.y = ;<br />
    vector2d.space = continuous_move_ip;

    struct tt__Vector1D vector1d;<br />
    vector1d.x = ;<br />
    vector1d.space = continuous_zoom_ip;

    struct tt__PTZSpeed ptzspeed;<br />
    ptzspeed.PanTilt = &amp;vector2d;<br />
    ptzspeed.Zoom = &amp;vector1d;

    req.ProfileToken = "Profile_1";<br />
    req.Velocity = &amp;ptzspeed;

    SOAP_ASSERT(NULL != (soap = ONVIF_soap_new(SOAP_SOCK_TIMEOUT)));

    result = ONVIF_SetAuthInfo(soap, USERNAME, PASSWORD);<br />
    printf("ONvif_SetAuthInfo is :%d\n" , result);<br />
    result = soap_call___tptz__ContinuousMove(soap , ptz_ip , NULL , &amp;req , &amp;resp);<br />
    printf("result is                     :%d\n" , result);

    ONVIF_soap_delete(soap);<br />
    return result;

}

void sig_fun(int signum)<br />
{<br />
    printf("stop roting \n");<br />
    ONVIF_Stop();<br />
    exit();<br />
}

int main(int argc, char **argv)<br />
{<br />
#if 0<br />
    signal(SIGINT , sig_fun);<br />
#endif

    //char device_ip[128] = {0};<br />
    char *device_ip = "http://192.168.235.201/onvif/device_service";<br />
    char media_ip[] = {};<br />
    char new_ip[] = {};<br />
    //char ptz_ip[128] = {0};<br />
    char *ptz_ip = "http://192.168.235.201/onvif/PTZ";<br />
    char device_token[] = {};<br />
    //char absolute_ip[128] = {0};<br />
    char *absolute_move_ip = "http://www.onvif.org/ver10/tptz/PanTiltSpaces/PositionGenericSpace";<br />
    //char zoom_ip[128] = {0};<br />
    char *absolute_zoom_ip = "http://www.onvif.org/ver10/tptz/ZoomSpaces/PositionGenericSpace";<br />
    //char *addr = NULL;<br />
    //struct tagProfile *profiles = NULL;<br />
    char *relative_move_ip = "http://www.onvif.org/ver10/tptz/PanTiltSpaces/TranslationGenericSpace";<br />
    char *relative_zoom_ip = "http://www.onvif.org/ver10/tptz/ZoomSpaces/TranslationGenericSpace";

    char *continuous_move_ip = "http://www.onvif.org/ver10/tptz/PanTiltSpaces/VelocityGenericSpace";<br />
    char *continuous_zoom_ip = "http://www.onvif.org/ver10/tptz/ZoomSpaces/VelocityGenericSpace";<br />
    int result = ;

    //ONVIF_Get_Gateway(device_ip);

    ONVIF_SetNetworkDefaultGateway(device_ip);

#if 1<br />
#if 0<br />
    char device_service_ip[] = {"http://192.168.235.200/onvif/device_service"};<br />
#endif<br />
    /*get device ip*/<br />
    ONVIF_DetectDevice(NULL , device_ip);<br />
    printf("device ip is :%s\n" , device_ip);<br />
    /*get device token*/<br />
    //ONVIF_GetZeroConfiguration(device_ip , device_token);

#if 1<br />
    //printf("\n\n");<br />
    printf("please input new ip :");<br />
    scanf("%s" , new_ip);<br />
    printf("new_ip is :%s\n" , new_ip);<br />
    if(strcmp(new_ip , "q") != )<br />
    {<br />
        result = ONVIF_SetNetworkInterfaces(device_ip , new_ip , device_token);<br />
        printf("result of set ip is           :%d\n" , result);<br />
        sleep();<br />
        ONVIF_DetectDevice(NULL , device_ip);<br />
        printf("\n\n");<br />
    }<br />
#endif<br />
    //get device info<br />
    ONVIF_GetDeviceInformation(device_ip);<br />
    //get capabilities<br />
    ONVIF_GetCapabilities(device_ip , media_ip , ptz_ip);<br />
    printf("ptz_ip is                 :%s\n" , ptz_ip);<br />
    //get profiles<br />
    result = ONVIF_Media_GetProfiles(media_ip);<br />
    result = ONVIF_PTZ_GetProfiles(media_ip , absolute_ip , zoom_ip);<br />
    printf("abusolute ip is :%s\n" , absolute_ip);<br />
    printf("zoom_ip ip is   :%s\n" , zoom_ip);<br />
#endif<br />
#if 1<br />
    ONVIF_AbsoluteMove(ptz_ip , absolute_move_ip , absolute_zoom_ip);<br />
    //printf("result is :%d\n" , result);<br />
#endif

#if 1<br />
    ONVIf_RelativeMove(ptz_ip , relative_move_ip , relative_zoom_ip);<br />
#endif

#if 1<br />
    ONVIF_ContinuousMove(ptz_ip , continuous_move_ip , continuous_zoom_ip);<br />
    while();<br />
    return ;<br />
#endif<br />
}</pre>
</div>
<pre class="prettyprint linenums"><code>&nbsp;</code></pre>
<div>&nbsp;</div>
</div>
<div>&nbsp;</div>
<p>&lt;wiz_tmp_tag id="wiz-table-range-border" contenteditable="false" style="display: none;"&gt;</p>
<div>&nbsp;</div>
<div>&nbsp;</div>
<div>&nbsp;</div>
<div>&nbsp;</div>
<div><a href="http://www.wiz.cn/i/1804c66c" rel="external nofollow noreferrer">来自为知笔记(Wiz)</a></div>
<ul><li>Add to Phrasebook</p>
<div>&nbsp;</div>
<ul><li>No wordlists for English -&gt; Simplified Chinese...</p>
<div>&nbsp;</div></li>
<li>Create a new wordlist...</li></ul></li>
<li>Copy</li></ul>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/e9p3rv4q.html">windows下docker环境设置</a>
		</li>
						<li><a href="https://www.batexi.com/a/jqdlv2z8.html">JavaScript函数之美~</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8k4emj9.html">MyEclipse取消自动跳到Console窗口</a>
		</li>
						<li><a href="https://www.batexi.com/a/m96eov3q.html">支持事件穿透？使用pointer-events样式</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqv4gloq.html">边工作边刷题：70天一遍leetcode&colon; day 82-1</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwdjm5y8.html">jQuery中的ajax服务端返回方式详细说明</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4yjmdjq.html">bzojj1764&colon; &lbrack;Baltic2009&rsqb;monument</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxnldrd8.html">windows 上配置solr5&period;2&period;1&plus;solr4&period;3&plus;中文分词器</a>
		</li>
						<li><a href="https://www.batexi.com/a/95xyle08.html">8-13-Exercise</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k143j79.html">Web Services之SOAP学习</a>
		</li>
						<li><a href="https://www.batexi.com/a/90v34r38.html">QE是什么</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rdv4448.html">My way on Linux - &lbrack;Shell基础&rsqb; - Bash Shell中判断文件、目录是否存在或者判断其是否具有某类属性&lpar;权限&rpar;的常用方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2w7lm3q.html">dos下遍历目录和文件的代码&lpar;主要利用for命令&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/9503g6z8.html">linux添加swap</a>
		</li>
						<li><a href="https://www.batexi.com/a/950d4008.html">NoSql数据库简介及Redis学习</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jz5vk08.html">大数据学习之hdfs集群安装部署04</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rgjgn78.html">Python中的作用域及global用法</a>
		</li>
						<li><a href="https://www.batexi.com/a/960jxyj9.html">关于HTMl   CSS</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j1l7o09.html">servlet injection analysis</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j141g49.html">jQuery-数据管理-删除事件</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/8o42pylq.html">opencv产生随机的颜色</a>
			</li>
						<li><a href="https://www.batexi.com/a/qve7poz9.html">markdown小记（语法&plus;markdownpad）</a>
			</li>
						<li><a href="https://www.batexi.com/a/953nke68.html">Spring4笔记9--Spring的事务管理（AOP应用的例子）</a>
			</li>
						<li><a href="https://www.batexi.com/a/8mjx5y08.html">imperva 更改web界面的密码</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdjxy40q.html">为什么使用do&lbrace;&rcub;while&lpar;0&rpar;来进行宏定义</a>
			</li>
						<li><a href="https://www.batexi.com/a/qve7l719.html">pymongo的几个操作</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7ejkex9.html">Django-ORM简介</a>
			</li>
						<li><a href="https://www.batexi.com/a/qyvoz2mq.html">DenseNet笔记</a>
			</li>
						<li><a href="https://www.batexi.com/a/953n4nz8.html">缓存数据库-redis安装和配置</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7ej6wg9.html">python基础--类的方法</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
